/*******************************************************************************
 * @author    Patricie Benešová
 * @version   1.00.000
 */
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
public class TrideniZamestnancu
{
    private List<Zamestnanec> seznamZamestnancu = new ArrayList<>();

    public TrideniZamestnancu() {
        seznamZamestnancu.add(new Zamestnanec("Pavel Janata", Pohlavi.MUZ, "opravar"));
        seznamZamestnancu.add(new Zamestnanec("Marie Mikonova", Pohlavi.ZENA, "uklizecka"));
        seznamZamestnancu.add(new Zamestnanec("Marcel Zavadil", Pohlavi.MUZ, "CEO"));
        seznamZamestnancu.add(new Zamestnanec("Monika Rackova", Pohlavi.ZENA, "asistentka"));
    }

    /**
     * Getter pro získání seznamu zaměstnanců
     */
    public List<Zamestnanec> getSeznamZamestnancu() {
        return seznamZamestnancu;
    }
    
    /**
     * Seskupení zaměstnanců dle pohlaví pomocí metody partitioningBy()
     */
    public Map<Boolean,List<Zamestnanec>> setMapa(List<Zamestnanec> seznam){
        return seznam.stream().collect(Collectors.partitioningBy((p)-> p.getPohlavi()==Pohlavi.MUZ));
    }
    
    /**
     * Seskupení zaměstnanců dle pohlaví pomocí metody groupingBy()
     */
    public Map<Pohlavi , List<Zamestnanec>> setMapa2(List<Zamestnanec> seznam){
        return seznam.stream().collect(Collectors.groupingBy((p)-> p.getPohlavi()));
    }

     public static void main(String[] args) {
        TrideniZamestnancu n = new TrideniZamestnancu();
 
        System.out.println(n.setMapa(n.getSeznamZamestnancu()));
         System.out.println(n.setMapa2(n.getSeznamZamestnancu()));
    }

}
